{$M $4000,0,600000}
Program   CityScape;

uses      Dos,Crt,vars,Func,Misc,Mapper;

Type      tsh       = array[0..17,0..15] of byte;
          psh       = ^tsh;
          tscr      = array[0..199,0..319] of byte;
          pscr      = ^tscr;


const     { Keyboard stuff }
          TargetInt      = $15;
          CtrlScan       = $1D;
          AltScan        = $38;
          DelScan        = $53;
          NumLockScan    = $45;
          ScrollLockScan = $46;
          Release        = $80;
          EscUP          = $81;

          TimerBar       = False;
          deg            = 57.29577951;

          cx=160;
          cy=100;

          UDir = 1;
          DDir = 2;
          LDir = 4;
          RDir = 8;
          FDir = 16;
          F2Dir = 32;

          ScreenXsize=352;
          ScreenYsize=200;

VAR
          fMap     : file;
          ScanCode : word;



          ScanUp    : byte;
          ScanDown  : byte;
          ScanLeft  : byte;
          ScanRight : byte;
          ScanFire : byte;
          ScanGranade : byte;

          Dir : word;
          KbCall : procedure;

          x,y,xl,yl : word;

          Ctrl : boolean;
          Alt : Boolean;
          Del : Boolean;
          ScrollLock: boolean;
          NumLock : boolean;

          Panelt : word;

          NextDir : word;
          LastF   : boolean;
          Panel   : Pointer;
		PanelS  : longint;

          BonCount: longint;
		PDelay : word;
		HiScore  : longint;
          HiName  : string[7];
          Miss    : word;

          iii     : byte;
          tobj	   : pointer;
          tsize   : longint;


		B1	: array [0..2000] of byte;
		B2	: array [0..2000] of byte;

          bx1,bx2 : integer;
          by1,by2 : integer;

          cc,tt : word;
          sx,sy : word;

          vesa  : array[0..256] of byte;
          p     : pointer;
          SVGA  : boolean;

(************************************************************************)
(*
(*   Keyboard handler!
(*
(************************************************************************)
procedure IntSave; assembler;
asm
  dw 0
  dd 0
end; { IntSave }

{$ifopt S+}
  {$define SPlus}
  {$S-}
{$endif}
procedure IntHandler(Flags, CS, IP, AX, BX, CX, DX,
                     SI, DI, DS, ES, BP: Word); interrupt;
begin
  if Hi(AX) = $4F then
  begin
    Flags := Flags or FCarry;
    case Lo(AX) of
        NumLockScan             :    NumLock:=True;
        NumLockScan + Release   :    NumLock:=False;
        ScrollLockScan          :    ScrollLock:=True;
        ScrollLockScan + Release:    ScrollLock:=False;
        CtrlScan                :    Ctrl := True;
        AltScan                 :    Alt := True;
        DelScan                 :    Del := True;
        CtrlScan + Release      :    Ctrl := False;
        AltScan + Release       :    Alt := False;
        DelScan + Release       :    Del := False;
    end;
    ScanCode:=lo(AX);

    if lo(ax)=ScanUp then Dir:=Dir or 1;
    if lo(ax)=ScanDown then Dir:=Dir or 2;
    if lo(ax)=ScanLeft then Dir:=Dir or 4;
    if lo(ax)=ScanRIght then Dir:=Dir or 8;
    if lo(ax)=ScanFire then Dir:=Dir or 16;
    if lo(ax)=ScanGranade then Dir:=Dir or 32;

    if lo(ax)=ScanUp+release then Dir:=Dir and (255-1);
    if lo(ax)=ScanDown+release then Dir:=Dir and (255-2);
    if lo(ax)=ScanLeft+release then Dir:=Dir and (255-4);
    if lo(ax)=ScanRIght+release then Dir:=Dir and (255-8);
    if lo(ax)=ScanFire+release then Dir:=Dir and (255-16);
    if lo(ax)=ScanGranade+release then Dir:=Dir and (255-32);


    if Ctrl and Alt and Del then
      Flags := Flags and not FCarry;
    Exit;
  end
  else
  asm
    push bp
    push &Flags
    mov ax, &AX
    mov bx, &BX
    mov cx, &CX
    mov dx, &DX
    mov si, &SI
    mov di, &DI
    mov ds, &DS
    mov es, &ES
    mov bp, &BP
    call dword ptr [IntSave]
    push bp
    mov bp, sp
    mov bp, [bp+2]
    pushf
    pop &Flags
    mov &AX, ax
    mov &BX, bx
    mov &CX, cx
    mov &DX, dx
    mov &SI, si
    mov &DI, di
    mov &DS, ds
    mov &ES, es
    pop &BP
    add sp, 2
  end;
end; { IntHandler }
{$ifdef SPlus}
  {$undef SPlus}
  {$S+}
{$endif}
(************************************************************************)
(************************************************************************)
Procedure Quit;
Begin
     SetIntVec(TargetInt, Pointer(@IntSave^));
     halt;
End;

(************************************************************************)
(*
(*	Mask DIR. IRQ's MUST be off, as a conflict "may" occur.
(*
(************************************************************************)
Procedure MaskDir(mask : byte);	{ lose FIRE bit }
Begin
     asm  cli end;
     Dir:=Dir and mask;
     asm  sti end;
End;

(************************************************************************)
(* return HEX value for a byte.
(************************************************************************)
function HexByte(B: Byte): String;
const
  HexChars: array [0..$F] of Char =
    '0123456789ABCDEF';
begin
  HexByte := HexChars[B shr 4] + HexChars[B and $F];
end; { HexByte }


(************************************************************************)
(*
(*   Clear KeyBoard Buffer
(*
(************************************************************************)
Procedure ClearKeyBoardBuffer;
const     KbBuffHead = $1a;
          KbBuffTail = $1C;
VAR       BiosDataArea : word;

Begin
     BiosDataArea:=Seg0040;
     asm  cli end;
     MemW[BiosDataArea:KbBuffHead] :=MemW[BiosDataArea:KbBuffTail];
     asm  sti end;
End;


(************************************************************************)
(*
(*	Do MISC routines
(*
(************************************************************************)
Procedure MiscStuff;
Begin
	if (TimerBar) then SetColour (0,64,0,0);

     px:=panX and $fff0;
     py:=panY and $fff0;
End;

(************************************************************************)
(*
(*   Copy Screen over!
(*
(************************************************************************)
Procedure CopyScreen;
Begin
     if (SVGA=TRUE) then
     Begin
          CopyMapScreen;
          asm
             mov    ax,$4f05
             mov    bx,0
             mov    dx,15
             int    $10
          end;
          CopyMapScreen2;
          asm
             mov    ax,$4f05
             mov    bx,0
             mov    dx,0
             int    $10
          end;
      End
     else
      Begin
          Scrbase:=((320-Wx) div 2 )+(((200-Wy) div 2)*320);
          CopyMAPSize;
          {Copy320MapScreen;}
      End;

End;

(************************************************************************)
(*
(*   Play Actual Game!
(*
(************************************************************************)
Procedure  PlayGame;
           VAR done : boolean;
           VAR i : word;
           VAR speed,px,py,x : integer;
          VAR ind2,ind : integer;
          VAr ii,iii,index : word;
          VAr yy,yy2 : word;
          VAR cx,cy,cz : longint;
          var lastcode  : byte;
          VAR windowX,WindowY : integer;
Begin
	for i:=0 to 255 do
     	SetColour (i,Colours^[i].r shl 2,Colours^[i].g shl 2,Colours^[i].b shl 2);
     {xx:=16; yy:=16;}
     ScanCode:=0;
     ScrBase:=0;
     Done:=False;
     PanX:=16; PanY:=0;
     ScrBase:=0;

     Ang:=2.2999999;
     rad:=192; {158;}
     rad2:=75; {62;}
{     rad:=12;
     rad2:=8;}
{     ind:=102;
     ind2:=165;
     ii:=150;
     iii:=181;}

{     ind:=102;
     ind2:=165;
     ii:=(135*2);
     iii:=(166*2);
     yy:=115;
     yy2:=178;}

     ccx:=160;
     ccy:=90;
     cx:=44;
     cx:=204;
     cy:=24;
     cz:=-246;
     ind:=102+130;
     ind2:=165+130;
     ii:=(135*2)+(50*2);
     iii:=(166*2)+(50*2);
     yy:=115;
     WindowX:=320;
     WindowY:=200;
     yy2:=178;
{     rad:=407.0;
     rad2:=365.0;}
{     Vars.SetWindow (160,100);}
     Vars.SetWindow (WindowX,WindowY);
     level:=1;
     Speed:=4;
     WorkOutGrid;
     repeat
          setcolour(255,255,255,255);
          setcolour(128,128,128,128);
          waitVblank;
          CopyScreen;
          MiscStuff;

          {ClearScreen;}
		ClearMapScreen;


          GetPerspectivegrid (cx,cy,cz);
          {WaitVblank;}
          if SSide=16 then col:=true;
          {if col then SetColour (0,255 ,0,0);}
          DrawMapBlocks;
          {if col then SetColour (0,0,0,0);}
          col:=false;



          key:=#0;
          key:=GetKey;

{          if key='z' then
          Begin
               inc (yy);
               inc (yy2);
          End;
          if key='a' then
          Begin
               dec (yy);
               dec (yy2);
          End;}

          if scancode=52 then cx:=cx+speed;
          if scancode=51 then cx:=cx-speed;

          if scancode=16 then cz:=cz+speed;
          if scancode=30 then cz:=cz-speed;

          if scancode=31 then cy:=cy+speed;
          if scancode=17 then cy:=cy-speed;
          if key='w' then
           lastcode:=scancode;


{          if scancode=45 then cy:=cy+4;
          if scancode=44 then cy:=cy-4;}

          if key='[' then ccx:=ccx+4;
          if key=']' then ccx:=ccx-4;
          if key='z' then ccy:=ccy+4;
          if key='x' then ccy:=ccy-4;

          if key='1' then dist:=dist+1;
          if key='2' then dist:=dist-1;

          if key=' ' then sside:=Sside xor 16;


          if (key='3') and (level>1) then dec (level);
          if (key='4') and (level<6) then inc (level);

          if (key='9') and (speed>1) then dec (speed);
          if (key='0') and (speed<30) then inc (speed);

          if key='-' then begin Dec (WindowX,4); Dec (WindowY,4); Vars.SetWindow (WindowX,WindowY); End;
          if key='=' then begin inc (WindowX,4); inc (WindowY,4); Vars.SetWindow (WindowX,WindowY); End;


          ClearKeyBoardBuffer;
     until (done) or (key=#27);
     writeln ('hello');
End;


(************************************************************************)
(*
(*   Main loop
(*
(************************************************************************)
Begin
     col:=false;
     SVGA:=false;
     p:=@vesa;
{     asm
        push   es
        push   di
        les    di,p
        mov    ax,$4f01
        mov    cx,$100
        int    $10
        pop    di
        pop    es
     End;
     Writeln ('Mode 640x400');
     Writeln ('granularity='+rstr(vesa[4]+(vesa[5]*256))+' in KB');
     Writeln ('Window Size='+rstr(vesa[6]+(vesa[7]*256))+' in KB');
     asm
        push   es
        push   di
        les    di,p
        mov    ax,$4f01
        mov    cx,$101
        int    $10
        pop    di
        pop    es
     End;
     Writeln ('Mode 640x480');
     Writeln ('granularity='+rstr(vesa[4]+(vesa[5]*256))+' in KB');
     Writeln ('Window Size='+rstr(vesa[6]+(vesa[7]*256))+' in KB');
     halt;}

     PanX:=0; PanY:=0;

     checkbreak:=False;
     Randomize;
     ScanUp:=$10;
     ScanDown:=$1e;
     ScanLeft:=$18;
     ScanRight:=$19;
     ScanFire:=$39;
     ScanGranade:=AltScan;

     Load ('64x64.col',Panel,PanelS);
     Load ('64x64.dat',ground,groundS);

     Colours:=Panel;
     Dir:=0;

     GetIntVec(TargetInt, Pointer(@IntSave^));
     SetIntVec(TargetInt, Addr(IntHandler));

     SetClipWindow (0,0,ScreenXsize,ScreenYsize-8);

     Setmode;
     if (SVGA=true) then
     Begin
      asm
        mov    ax,$4f02
        mov    BX,$101
        int    $10
      End;
     End;
     screenX:=320;

     PlayGame;

     SetIntVec(TargetInt, Pointer(@IntSave^));
	restoremode;
End.
