;--------------------------------------------------
;
; Data
;
DATA		SEGMENT WORD PUBLIC
		ASSUME	DS:DATA

EXTRN	PlaneTotal:	word
EXTRN	ScrBase	:	word
EXTRN	ScreenX2	:	word
EXTRN	ScreenY	:	word
EXTRN     Wx1       :    word
EXTRN     Wx2       :    word
EXTRN     Wy1       :    word
EXTRN     Wy2       :    word
EXTRN	Clipped	:	word

EXTRN	Plane1	:	Dword
EXTRN	Plane2	:	Dword
EXTRN	Plane3	:	Dword
EXTRN	Plane4	:	Dword

EXTRN	MaskScreen:	Dword
EXTRN	Scr       :	Dword

EXTRN	RealScreen:	Dword

EXTRN    scx :           Dword;
EXTRN    scy :           Dword;
EXTRN    Dx1 :           Dword;
EXTRN    Dy1 :           Dword;
EXTRN    Dx2 :           Dword;
EXTRN    Dy2 :           Dword;
EXTRN    scrbuff:        Dword;
EXTRN    PolyPoints:     Dword;
EXTRN    PolyNumber:     word;
EXTRN    PolyCol   :     byte;

EXTRN    Ty1        : word;
EXTRN    Tx1        : word;
EXTRN    TDy        : Dword;
EXTRN    TDx        : Dword;
EXTRN    Tx2        : Dword;
EXTRN    TScaleX    : Dword;
EXTRN    TShape     : Dword;
EXTRN    Tscy       : Dword;

EXTRN     Wx       :    word
EXTRN     Wy       :    word

DATA		ENDS


;--------------------------------------------------
;
; Code
;
          .286

CODE 	SEGMENT PUBLIC
		ASSUME	CS:CODE

ScreenWidth              equ  352/4

SEQ_ADDR		          equ	03C4h
SEQ_DATA	    	          equ	03C5h
SEQ_MEMORY_MODE		equ	4
SEQ_04h_C4		     equ	8
SEQ_04h_OE		     equ	4
SEQ_04h_EM		     equ	2


GRAPHC_ADDR		     equ	03CEh
GRAPHC_DATA		     equ	03CFh
GRAPHC_SR		          equ	0
GRAPHC_ENABLE_SR	     equ	1
GRAPHC_DATA_ROTATE	     equ	3
GRAPHC_MODE		     equ	5
GRAPHC_BIT_MASK	     equ	8

SHIFT_REG_2		     equ	040h
READ_MODE_0		     equ	0
READ_MODE_1		     equ	8
WRITE_MODE_0		     equ	0
WRITE_MODE_1		     equ	01
WRITE_MODE_2		     equ	02
WRITE_MODE_3		     equ	03

VIDSEG				equ	0A000h
VRAM                     equ	0A000h
VRAM_LIMIT               equ	01000h


SSTAKEL	macro
			push	bp					; // Fix stack for local variables
			mov	bp,sp
			sub	sp,AUTO_SIZE
          endm

SSTACK  	macro
			push	bp					; // Fix stack for local variables
			mov	bp,sp
		endm

RSTACK	macro
			mov	sp,bp					; // restore stack for exit
			pop	bp
		endm



Draw16Lines macro
               movsd                ; store 16/4 pixels (4 pixels)
               add  di,cx
            endm

            .386P
;******************************************************************************
;
; Copy Map TEST screen over
;
;******************************************************************************
testProc  proc far
           mov   bl,ds:[si+0]
           mov   es:[di+0],bl
           align 4
           mov   bl,ds:[si+040h]
           mov   es:[di+040h],bl
           align 4
           mov   bl,ds:[si+080h]
           mov   es:[di+080h],bl
           align 4
           mov   bl,ds:[si+1080h]
           mov   es:[di+1080h],bl
           align 4
testProc  endp

Copy320Map  PROC	FAR
     	Public Copy320MapScreen

Copy320MAPScreen:
          SSTack


 		push	di
          push	es
          push	ds


          les	di,Plane1
          mov  ax,VidSeg       ; get BASE of VRAM
          ;mov  ax,word ptr RealScreen+4       ; get BASE of VRAM
          mov  es,ax
          mov	bx,ScrBase
          lds	si,Plane1

          mov  cx,200
All2_:    mov  bx,80
ll_:      mov  eax,ds:[si]
          mov  es:[di],eax
          add  si,4          ;16
          add  di,4          ;16
          dec  bx
          jnz  ll_
          ;add  di,320
          dec  cx
          jnz  All2_

          pop  ds
          pop  es
          pop  di

          RSTACK
          ret

Copy320Map  ENDP

;****************************************************************************
;
;
;
;****************************************************************************
Copy320Map2  PROC	FAR
     	Public CopyMapSize

_Temp     dw     0
CopyMAPSize:
          SSTack


 		push	di
          push	es
          push	ds
          push	gs


          mov  ax,VidSeg       ; get BASE of VRAM
          mov  es,ax
          mov	di,ScrBase      ; base of screen!
          lgs	si,Plane1

          mov  cx,Wy
CpyLoop:  mov  bx,Wx
          shr  bx,2
CpyIn:    mov  eax,gs:[si]
          mov  es:[di],eax
          add  si,4          ;16
          add  di,4          ;16
          dec  bx
          jnz  CpyIn
          mov  bx,320
          sub  bx,Wx
          add  di,bx
          add  si,bx

          dec  cx
          jnz  CpyLoop

          pop  gs
          pop  ds
          pop  es
          pop  di

          RSTACK
          ret

Copy320Map2  ENDP

;******************************************************************************
;
; Copy Map TEST screen over
;
;******************************************************************************
CopyMap  PROC	FAR
     	Public CopyMapScreen

CopyMapScreen:
          SSTack


 		push	di
          push	es
          push	ds


          les	di,Plane1
          ;mov  ax,word ptr RealScreen+4       ; get BASE of VRAM
          mov  ax,VidSeg       ; get BASE of VRAM
          mov  es,ax
          mov	bx,ScrBase
          lds	si,Plane1
          add  di,160

          mov  cx,100
All2:     mov  bx,80
ll:       mov  eax,ds:[si]
          mov  es:[di],eax
          add  si,4          ;16
          add  di,4          ;16
          dec  bx
          jnz  ll
          add  di,320
          dec  cx
          jnz  All2

          pop  ds
          pop  es
          pop  di

          RSTACK
          ret

CopyMap  ENDP


;******************************************************************************
;
; Copy Map TEST screen over 2!
;
;******************************************************************************
CopyMap2  PROC	FAR
     	Public CopyMapScreen2

CopyMapScreen2:
          SSTack


 		push	di
          push	es
          push	ds


          les	di,Plane1
          ;mov  ax,word ptr RealScreen+4       ; get BASE of VRAM
          mov  ax,VidSeg       ; get BASE of VRAM
          mov  es,ax
          mov	bx,ScrBase
          lds	si,Plane1
          add  si,96*320     ; 96*320
          add  di,160

          mov  cx,100
_All2:    mov  bx,80
_ll:      mov  eax,ds:[si]
          mov  es:[di],eax
          add  si,4          ;16
          add  di,4          ;16
          dec  bx
          jnz  _ll

          add  di,320
          dec  cx
          jnz  _All2

          pop  ds
          pop  es
          pop  di

          RSTACK
          ret

CopyMap2  ENDP

;******************************************************************************
;
; CLEAR Map screen
;
;******************************************************************************
ClearMap  PROC	FAR
     	Public  ClearMapScreen

ClearMapScreen:
          SSTack


 		push	di
          push	es
          push	ds


          les	di,Plane1

          xor  eax,eax
          mov  ecx,200
ll2:

          mov  es:[di],eax
          mov  es:[di+4],eax
          mov  es:[di+8],eax
          mov  es:[di+12],eax
          mov  es:[di+16],eax
          mov  es:[di+20],eax
          mov  es:[di+24],eax
          mov  es:[di+28],eax
          mov  es:[di+32],eax
          mov  es:[di+36],eax

          mov  es:[di+40],eax
          mov  es:[di+44],eax
          mov  es:[di+48],eax
          mov  es:[di+52],eax
          mov  es:[di+56],eax
          mov  es:[di+60],eax
          mov  es:[di+64],eax
          mov  es:[di+68],eax
          mov  es:[di+72],eax
          mov  es:[di+76],eax

          mov  es:[di+80],eax
          mov  es:[di+84],eax
          mov  es:[di+88],eax
          mov  es:[di+92],eax
          mov  es:[di+96],eax
          mov  es:[di+100],eax
          mov  es:[di+104],eax
          mov  es:[di+108],eax
          mov  es:[di+112],eax
          mov  es:[di+116],eax


          mov  es:[di+120],eax
          mov  es:[di+124],eax
          mov  es:[di+128],eax
          mov  es:[di+132],eax
          mov  es:[di+136],eax
          mov  es:[di+140],eax
          mov  es:[di+144],eax
          mov  es:[di+148],eax
          mov  es:[di+152],eax
          mov  es:[di+156],eax


          mov  es:[di+160],eax
          mov  es:[di+164],eax
          mov  es:[di+168],eax
          mov  es:[di+172],eax
          mov  es:[di+176],eax
          mov  es:[di+180],eax
          mov  es:[di+184],eax
          mov  es:[di+188],eax
          mov  es:[di+192],eax
          mov  es:[di+196],eax


          mov  es:[di+200],eax
          mov  es:[di+204],eax
          mov  es:[di+208],eax
          mov  es:[di+212],eax
          mov  es:[di+216],eax
          mov  es:[di+220],eax
          mov  es:[di+224],eax
          mov  es:[di+228],eax
          mov  es:[di+232],eax
          mov  es:[di+236],eax


          mov  es:[di+240],eax
          mov  es:[di+244],eax
          mov  es:[di+248],eax
          mov  es:[di+252],eax
          mov  es:[di+256],eax
          mov  es:[di+260],eax
          mov  es:[di+264],eax
          mov  es:[di+268],eax
          mov  es:[di+272],eax
          mov  es:[di+276],eax


          mov  es:[di+280],eax
          mov  es:[di+284],eax
          mov  es:[di+288],eax
          mov  es:[di+292],eax
          mov  es:[di+296],eax
          mov  es:[di+300],eax
          mov  es:[di+304],eax
          mov  es:[di+308],eax
          mov  es:[di+312],eax
          mov  es:[di+316],eax

          add  di,320
          dec  cx
          jnz  ll2

          pop  ds
          pop  es
          pop  di

          RSTACK
          ret

ClearMap  ENDP



;******************************************************************************
;
; CLEAR Map screen
;
;******************************************************************************
ClearScr  PROC	FAR
     	Public  ClearScreen

ClearScreen:
          SSTack


 		push	di
          push	es
          push	ds


          les	di,scr

          xor  eax,eax
          mov  ecx,200
sll2:

          mov  es:[di],eax
          mov  es:[di+4],eax
          mov  es:[di+8],eax
          mov  es:[di+12],eax
          mov  es:[di+16],eax
          mov  es:[di+20],eax
          mov  es:[di+24],eax
          mov  es:[di+28],eax
          mov  es:[di+32],eax
          mov  es:[di+36],eax

          mov  es:[di+40],eax
          mov  es:[di+44],eax
          mov  es:[di+48],eax
          mov  es:[di+52],eax
          mov  es:[di+56],eax
          mov  es:[di+60],eax
          mov  es:[di+64],eax
          mov  es:[di+68],eax
          mov  es:[di+72],eax
          mov  es:[di+76],eax

          mov  es:[di+80],eax
          mov  es:[di+84],eax
          mov  es:[di+88],eax
          mov  es:[di+92],eax
          mov  es:[di+96],eax
          mov  es:[di+100],eax
          mov  es:[di+104],eax
          mov  es:[di+108],eax
          mov  es:[di+112],eax
          mov  es:[di+116],eax


          mov  es:[di+120],eax
          mov  es:[di+124],eax
          mov  es:[di+128],eax
          mov  es:[di+132],eax
          mov  es:[di+136],eax
          mov  es:[di+140],eax
          mov  es:[di+144],eax
          mov  es:[di+148],eax
          mov  es:[di+152],eax
          mov  es:[di+156],eax


          mov  es:[di+160],eax
          mov  es:[di+164],eax
          mov  es:[di+168],eax
          mov  es:[di+172],eax
          mov  es:[di+176],eax
          mov  es:[di+180],eax
          mov  es:[di+184],eax
          mov  es:[di+188],eax
          mov  es:[di+192],eax
          mov  es:[di+196],eax


          mov  es:[di+200],eax
          mov  es:[di+204],eax
          mov  es:[di+208],eax
          mov  es:[di+212],eax
          mov  es:[di+216],eax
          mov  es:[di+220],eax
          mov  es:[di+224],eax
          mov  es:[di+228],eax
          mov  es:[di+232],eax
          mov  es:[di+236],eax


          mov  es:[di+240],eax
          mov  es:[di+244],eax
          mov  es:[di+248],eax
          mov  es:[di+252],eax
          mov  es:[di+256],eax
          mov  es:[di+260],eax
          mov  es:[di+264],eax
          mov  es:[di+268],eax
          mov  es:[di+272],eax
          mov  es:[di+276],eax


          mov  es:[di+280],eax
          mov  es:[di+284],eax
          mov  es:[di+288],eax
          mov  es:[di+292],eax
          mov  es:[di+296],eax
          mov  es:[di+300],eax
          mov  es:[di+304],eax
          mov  es:[di+308],eax
          mov  es:[di+312],eax
          mov  es:[di+316],eax

          add  di,320
          dec  cx
          jnz  sll2

          pop  ds
          pop  es
          pop  di

          RSTACK
          ret

ClearScr  ENDP



;     sx:=longint(x1)*256;
;     sy:=longint(y1)*256;
;
;     y:=0;
;     repeat
;      x:=0;
;      wsy:=sy;
;      wsx:=sx;
;      repeat
;            {if ((wsy shr 8) <200) and ((wsx shr 8)<320) then}
;            Screen^[(wsy shr 8),(wsx shr 8)]:=Shape^[(y shr 8),(x shr 8)];
;
;            x:=x+scx;   { move SHAPE forward }
;
;            wsx:=wsx+dx1;
;            wsy:=wsy+dy1;
;      until (x>=16*256);
;      sx:=sx-dx2;
;      sy:=sy-dy2;
;      y:=y+scy;
;     until (y>=18*256);
;End;



;******************************************************************************
;
;    Texture map a sprite.
;
;******************************************************************************
TextureMaps  PROC	FAR
		arg    Shape:Dword,y1pos:word,x1pos:word
     	Public TextureMap,_Table

          EVENDATA
cnt       =    320
_Table:   dw   0
          rept      200
          dw  cnt
cnt       = cnt+320
          endm
ScreenX   dw    320
Linetable  dw     1,320+1,1+(320*2),1+(320*3),1+(320*4),1+(320*5),1+(320*6),1+320*7,1+(320*8),1+(320*9),1+(320*10)
NextTline   dw     0,16,32,48,64,80,96,112,128,144,160,176,192,208,224,240,256

sx        dd     0
sy        dw     0
y         dw     0
x         dw     0
basesi    dw     0
basedi    dw     0
scrx      dw     0
_dx1      dd     0
_dx2      dd     0
_dy1      dw     0
_dy2      dw     0
_scx      dw     0
_scy      dw     0
count     dw     0
_bp       dw     0

TextureMap:  SSTack
 		push	di
          push	es
          push	ds

          mov  eax,dx1
          mov  _dx1,eax
          mov  eax,dx2
          mov  _dx2,eax
          mov  eax,dy1
          mov  _dy1,ax
          mov  eax,dy2
          mov  _dy2,ax
          mov  eax,scx
          mov  _scx,ax
          mov  eax,scy
          mov  _scy,ax

          les  di,Plane1
          mov  basedi,di

          xor  eax,eax
          mov  ax,ScreenX
          mov  scrx,ax

          mov  ax,x1pos        ; get X1 cord
          shl  eax,8            ; make 16 bit
          mov  sx,eax
          mov  ax,y1pos        ; get Y1 cord
          shl  eax,8            ; make 16 bit
          mov  sy,ax

          add  sy,128
          add  sx,128

          mov  Y,0
          mov  count,0
		lds	si,Shape		 ; get graphic address
          push bp

          Align 4
Yloop:    mov	bl,byte ptr sy+1
          xor  bh,bh
          add  bx,bx
          mov  bp,word ptr _Table[bx]    ;[ebx*2] is better
          add	bp,word ptr sx+1	      ; add on X cord
          mov  bx,0
          mov  dx,0

          mov  ecx,sx          ; ecx=x
          mov  ax,sy          ; ebx=y

          Align 4
;-----------------------------------
Xloop:    mov  bl,ds:[si+bx]
          mov  es:[di+bp],bl
          mov  es:[di+bp+1],bl

          add  ax,_dy1
          add  ecx,_dx1

          xor  ebx,ebx
          mov  bl,ah                     ; work out NEW X,Y pos on screen.
          add  bx,bx
          mov  bp,word ptr _Table[bx]    ;[ebx*2] is better
          shld ebx,ecx,24
          add  bp,bx

          xor  bx,bx
          add  dx,_scx                 ; get Fractional ADD for X
          mov  bl,dh
          cmp  dx,16*256               ; End of X loop?
          jb   Xloop
;---------------------------------
          mov  eax,_dx2
          add  sx,eax
          mov  ax,_dy2
          add  sy,ax

          mov  bx,Y
          add  bx,_scy
          mov  byte ptr Y,bl
          mov  bl,bh            ; shr  ax,8
          xor  bh,bh
          add  count,bx         ; current line count
          add  bx,bx
          add  si,word ptr NextTLine[bx]    ;[ebx*2] is better
          cmp  count,16
          jb   Yloop
          pop  bp

@Exitss:	pop	ds
          pop	es
          pop	di

          RSTACK
          ret  8

TextureMaps endp


CODE	ENDS
     END

;******************************************************************************
;
;    Draw scaled line on Y!
;
;******************************************************************************
DoLineY   macro  size,NoPixels,t2
          local  count,base,temp,cnt
TmpY_&t2:
          cnt=0
          count=(size*65536)/NoPixels              ; Make CODE
          base=0 ;count/2
          rept  NoPixels
             temp=base/65536
             ;mov   bl,ds:[si+(temp*size)]
             ;mov   es:[di+(cnt*320)],bl
             DB     08Ah,09Ch                     ; make instructions above.
             DB     LOW  (Temp*size)
             DB     HIGH (Temp*size)
             DB     026H,088h,09Dh
             DB     LOW  (cnt*320)
             DB     HIGH (cnt*320)
             base=(base+count)
             cnt=(cnt+1)
          endm
          ret
          endm

DoSpriteY macro size
          local count
             DoLineY  64,1,%1                     ; Loop round make code
             DoLineY  64,2,%2                     ; Loop round make code
             DoLineY  64,3,%3                     ; Loop round make code
             DoLineY  64,4,%4                     ; Loop round make code
             DoLineY  64,5,%5                     ; Loop round make code
             DoLineY  64,6,%6                     ; Loop round make code
             DoLineY  64,7,%7                     ; Loop round make code
             DoLineY  64,8,%8                     ; Loop round make code
             DoLineY  64,9,%9                     ; Loop round make code
             DoLineY  64,10,%10                     ; Loop round make code

             DoLineY  64,11,%11                     ; Loop round make code
             DoLineY  64,12,%12                     ; Loop round make code
             DoLineY  64,13,%13                     ; Loop round make code
             DoLineY  64,14,%14                     ; Loop round make code
             DoLineY  64,15,%15                     ; Loop round make code
             DoLineY  64,16,%16                     ; Loop round make code
             DoLineY  64,17,%17                     ; Loop round make code
             DoLineY  64,18,%18                     ; Loop round make code
             DoLineY  64,19,%19                     ; Loop round make code
             DoLineY  64,20,%20                     ; Loop round make code

             DoLineY  64,21,%21                     ; Loop round make code
             DoLineY  64,22,%22                     ; Loop round make code
             DoLineY  64,23,%23                     ; Loop round make code
             DoLineY  64,24,%24                     ; Loop round make code
             DoLineY  64,25,%25                     ; Loop round make code
             DoLineY  64,26,%26                     ; Loop round make code
             DoLineY  64,27,%27                     ; Loop round make code
             DoLineY  64,28,%28                     ; Loop round make code
             DoLineY  64,29,%29                     ; Loop round make code
             DoLineY  64,30,%30                     ; Loop round make code

             DoLineY  64,31,%31                     ; Loop round make code
             DoLineY  64,32,%32                     ; Loop round make code
             DoLineY  64,33,%33                     ; Loop round make code
             DoLineY  64,34,%34                     ; Loop round make code
             DoLineY  64,35,%35                     ; Loop round make code
             DoLineY  64,36,%36                     ; Loop round make code
             DoLineY  64,37,%37                     ; Loop round make code
             DoLineY  64,38,%38                     ; Loop round make code
             DoLineY  64,39,%39                     ; Loop round make code
             DoLineY  64,40,%40                     ; Loop round make code

             DoLineY  64,41,%41                     ; Loop round make code
             DoLineY  64,42,%42                     ; Loop round make code
             DoLineY  64,43,%43                     ; Loop round make code
             DoLineY  64,44,%44                     ; Loop round make code
             DoLineY  64,45,%45                     ; Loop round make code
             DoLineY  64,46,%46                     ; Loop round make code
             DoLineY  64,47,%47                     ; Loop round make code
             DoLineY  64,48,%48                     ; Loop round make code
             DoLineY  64,49,%49                     ; Loop round make code
             DoLineY  64,50,%50                     ; Loop round make code

             DoLineY  64,51,%51                     ; Loop round make code
             DoLineY  64,52,%52                     ; Loop round make code
             DoLineY  64,53,%53                     ; Loop round make code
             DoLineY  64,54,%54                     ; Loop round make code
             DoLineY  64,55,%55                     ; Loop round make code
             DoLineY  64,56,%56                     ; Loop round make code
             DoLineY  64,57,%57                     ; Loop round make code
             DoLineY  64,58,%58                     ; Loop round make code
             DoLineY  64,59,%59                     ; Loop round make code
             DoLineY  64,60,%60                     ; Loop round make code

             DoLineY  64,61,%61                     ; Loop round make code
             DoLineY  64,62,%62                     ; Loop round make code
             DoLineY  64,63,%63                     ; Loop round make code
             DoLineY  64,64,%64                     ; Loop round make code
         endm

;******************************************************************************
;
; Actual code bits, lines then tables
;
;******************************************************************************
ScaleLinesY proc
           public   ScaleLinesY

           DoSpriteY 64                            ; actually gen code.

ScaleLinesY Endp

ScaleLineTableY proc
           public  ScaleLineTableY                 ; actually gen table.

           dd      TmpY_1
           dd      TmpY_2
           dd      TmpY_3
           dd      TmpY_4
           dd      TmpY_5
           dd      TmpY_6
           dd      TmpY_7
           dd      TmpY_8
           dd      TmpY_9
           dd      TmpY_10

           dd      TmpY_11
           dd      TmpY_12
           dd      TmpY_13
           dd      TmpY_14
           dd      TmpY_15
           dd      TmpY_16
           dd      TmpY_17
           dd      TmpY_18
           dd      TmpY_19
           dd      TmpY_20

           dd      TmpY_21
           dd      TmpY_22
           dd      TmpY_23
           dd      TmpY_24
           dd      TmpY_25
           dd      TmpY_26
           dd      TmpY_27
           dd      TmpY_28
           dd      TmpY_29
           dd      TmpY_30

           dd      TmpY_31
           dd      TmpY_32
           dd      TmpY_33
           dd      TmpY_34
           dd      TmpY_35
           dd      TmpY_36
           dd      TmpY_37
           dd      TmpY_38
           dd      TmpY_39
           dd      TmpY_40

           dd      TmpY_41
           dd      TmpY_42
           dd      TmpY_43
           dd      TmpY_44
           dd      TmpY_45
           dd      TmpY_46
           dd      TmpY_47
           dd      TmpY_48
           dd      TmpY_49
           dd      TmpY_50

           dd      TmpY_61
           dd      TmpY_62
           dd      TmpY_63
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
           dd      TmpY_64
ScaleLineTableY endp


;******************************************************************************
;
;    Draw a scaled sprite. if over 64 pixels wide - ignore.
;
;         Tx1,Ty1    : word;
;         TDy        : word;
;         TDx        : Dword;
;         Tx2        : Dword;
;         TScaleX    : Dword;
;         TShape     : Dword;
;
;     xx:=(x1*$10000)+$8000;                 { get X start cord }
;     yy:=(y1*$10000)+$8000;                 { get Y start cord }
;     x:=$8000;                      { texture Y half way through pixel }
;     repeat
;           y:=0;
;           index:=(xx shr 16)+((yy shr 16)*320);
;           tindex:=(x shr 16);
;           repeat
;                 Screen^[index]:= shape^[((y shr 10) and $ffffffc0)+tindex];
;
;                 inc (y,tScaleX);            { do scale on X        }
;                 inc (index,320);            { next pixel on screen }
;           until (y>$400000);
;           inc (x,scy);
;           inc (xx,Dx1);
;           inc (yy,dy1);
;           t2:=t2-scaleX;
;           tScaleX:=$400000 div ((t2-yy+$10000) shr 16);
;     until (x>$400000);*)
;
;******************************************************************************
DrawaScaledBlockY  proc far
                  public DrawScaledBlockY

_y2          dd    0
_xx          dd    0
ty           dd    0
_Dx          dd    0
_Dy          dd    0
_tScy        dd    0
_ScaleX      dd    0
_x2          dd    0
_tt          dd    0

DrawScaledBlockY:
          SSTack
 		push	di
          push	es
          push	ds


          mov  eax,TscaleX    ; Copy Paramaters over
          mov  _ScaleX,eax
          mov  eax,Tscy       ; Copy Paramaters over
          mov  _tScy,eax
          mov  eax,Tdx        ; Copy Paramaters over
          mov  _Dx,eax
          mov  eax,Tdy
          mov  _Dy,eax
          mov  eax,Tx2
          mov  _y2,eax        ; Y axis this time!

          mov  cx,Tx1         ; scale x cord up!
          shl  ecx,16
          mov  ax,Ty1         ; scale Y cord up!
          shl  eax,16
          mov  edx,08000h

          les  di,Plane1
		lds	si,TShape		 ; get graphic address

@SLoopY:
          push si
          push di

          mov  ebx,eax         ; work out NEW X,Y pos on screen.
          shr  ebx,16
          add  bx,bx
          add  di,word ptr _Table[bx]    ;[ebx*2] is better
          shld ebx,ecx,16      ; Get X cord and add on.
          add  di,bx

          cmp  ecx,320*010000h
          jae  @SkipY


          mov  ebx,edx          ; work out new start in texture
          shr  ebx,16           ; (new start pixel)
          add  si,bx


          mov  _tt,eax
          mov  ebx,_y2         ; Work out address for line printing Jump table
          sub  ebx,eax         ; Get HEIGHT to print! (y2-y1)
          shr  ebx,14          ; shr 16, *4 (for jump table)
          and  bx,0FFFCh
          add  bx,offset ScaleLineTableY
          call cs:[bx]

@SkipY:
          mov  ebx,_ScaleX    ; Line Draw on Y (right side)
          sub  _Y2,ebx
          add  eax,_Dy
          add  ecx,_Dx        ; Line draw on X,Y (left side)
          add  edx,_tScy      ; Scale Texture on X axis
          mov  _xx,edx

          pop  di
          pop  si
          cmp  edx,0400000h
          jle  @SLoopY


@TExitY:	pop	ds
          pop	es
          pop	di

          RSTACK
          ret

DrawaScaledBlockY   endp


DrawaScaledBlockClippedY  proc far
                  public DSBClippedY

          EVENDATA
cnt       =    0
SkipTable:
          rept      63
          dw  cnt
cnt       = cnt+9
          endm
          rept 200
          dw   64*9
          endm
_Ybase       dw    0
_YClip       dw    0
_YSize       dw    0
_Yadd        dw    0
_TCX         dd    0

DSBClippedY:
          SSTack
 		push	di
          push	es
          push	ds


          mov  eax,TscaleX    ; Copy Paramaters over
          mov  _ScaleX,eax
          mov  eax,Tscy       ; Copy Paramaters over
          mov  _tScy,eax
          mov  eax,Tdx        ; Copy Paramaters over
          mov  _Dx,eax
          mov  eax,Tdy
          mov  _Dy,eax
          mov  eax,Tx2
          mov  _y2,eax        ; Y axis this time!

          mov  cx,Tx1         ; scale x cord up!
          shl  ecx,16
          mov  ax,Ty1         ; scale Y cord up!
          shl  eax,16
          mov  edx,08000h

          les  di,Plane1
		lds	si,TShape		 ; get graphic address

@SLoopY2:
          push si
          push di


          mov  ebx,eax
          shr  ebx,16
          mov  _Ybase,bx
          mov  _Yclip,0
          mov  _Yadd,0
          mov  _Ysize,0
          mov  ebx,eax         ; Work out address for line printing Jump table
          cmp  ebx,0
          jge  @okY
          shr  ebx,16
          neg  bx
          mov  _Ysize,bx
          add  bx,bx
          mov  bx,word ptr _Table[bx]
          mov  _Yadd,bx
          mov  bx,_YSize
          add  bx,bx           ; Get CLIP size
          mov  bx,word ptr SkipTable[bx]
          mov  _Yclip,bx
          mov  _Ybase,0
@OkY:
          mov  bx,_YBase
          add  bx,bx
          add  di,word ptr _Table[bx]    ;[ebx*2] is better
          shld ebx,ecx,16      ; Get X cord and add on.
          add  di,bx
          sub  di,_Yadd

          mov  _TCX,ecx
          cmp  ecx,320*010000h
          jae  @SkipY2


          mov  ebx,edx          ; work out new start in texture
          shr  ebx,16           ; (new start pixel)
          add  si,bx

          ;mov  _Yclip,0
          ;mov  _Ysize,0
          ;mov  ebx,eax         ; Work out address for line printing Jump table
          ;cmp  ebx,0
          ;jge  @okY
          ;shr  ebx,16
          ;neg  bx
          ;mov  _Ysize,bx
          ;add  bx,bx           ; Get CLIP size
          ;mov  bx,word ptr SkipTable[bx]
          ;mov  _Yclip,bx

;@okY:
          mov  ebx,_y2
          sub  ebx,eax         ; Get WIDTH to print!
          shr  ebx,16          ; shr 16, *4
          cmp  bx,_Ysize
          jl   @SkipY2

          ;mov  ebx,_y2         ; Work out address for line printing Jump table
          ;sub  ebx,eax         ; Get HEIGHT to print! (y2-y1)
          ;shr  ebx,14          ; shr 16, *4 (for jump table)
          ;and  bx,0FFFCh
          add   bx,bx
          add   bx,bx
          ;add  bx,offset ScaleLineTableY
          mov  bx,word ptr cs:ScaleLineTableY[bx]
          add  bx,_Yclip
          call bx

@SkipY2:
          mov  ebx,_ScaleX    ; Line Draw on Y (right side)
          sub  _Y2,ebx
          add  eax,_Dy
          add  ecx,_Dx        ; Line draw on X,Y (left side)
          add  edx,_tScy      ; Scale Texture on X axis
          mov  _xx,edx

          pop  di
          pop  si
          cmp  edx,0400000h
          jle  @SLoopY2


@TExitY2:	pop	ds
          pop	es
          pop	di

          RSTACK
          ret

DrawaScaledBlockClippedY  endp










;******************************************************************************
;
;
;    Draw scaled line
;
;******************************************************************************

DoLine   macro  size,NoPixels,t2
         local  count,base,temp,cnt
TmpX_&t2:
         cnt=0
         count=(size*65536)/NoPixels
         base=count/2
         rept  NoPixels
             temp=base/65536
             ;mov   bl,ds:[si+temp]
             ;mov   es:[di+cnt],bl
             DB     08Ah,09Ch                     ; make instructions above.
             DB     LOW  (Temp)
             DB     HIGH (Temp)
             DB     026H,088h,09Dh
             DB     LOW  (cnt)
             DB     HIGH (cnt)
             base=(base+count)
             cnt=(cnt+1)
         endm
         ret
         endm

DoSprite macro size
             DoLine  64,1,%1                     ; Loop round make code
             DoLine  64,2,%2                     ; Loop round make code
             DoLine  64,3,%3                     ; Loop round make code
             DoLine  64,4,%4                     ; Loop round make code
             DoLine  64,5,%5                     ; Loop round make code
             DoLine  64,6,%6                     ; Loop round make code
             DoLine  64,7,%7                     ; Loop round make code
             DoLine  64,8,%8                     ; Loop round make code
             DoLine  64,9,%9                     ; Loop round make code
             DoLine  64,10,%10                     ; Loop round make code

             DoLine  64,11,%11                     ; Loop round make code
             DoLine  64,12,%12                     ; Loop round make code
             DoLine  64,13,%13                     ; Loop round make code
             DoLine  64,14,%14                     ; Loop round make code
             DoLine  64,15,%15                     ; Loop round make code
             DoLine  64,16,%16                     ; Loop round make code
             DoLine  64,17,%17                     ; Loop round make code
             DoLine  64,18,%18                     ; Loop round make code
             DoLine  64,19,%19                     ; Loop round make code
             DoLine  64,20,%20                     ; Loop round make code

             DoLine  64,21,%21                     ; Loop round make code
             DoLine  64,22,%22                     ; Loop round make code
             DoLine  64,23,%23                     ; Loop round make code
             DoLine  64,24,%24                     ; Loop round make code
             DoLine  64,25,%25                     ; Loop round make code
             DoLine  64,26,%26                     ; Loop round make code
             DoLine  64,27,%27                     ; Loop round make code
             DoLine  64,28,%28                     ; Loop round make code
             DoLine  64,29,%29                     ; Loop round make code
             DoLine  64,30,%30                     ; Loop round make code

             DoLine  64,31,%31                     ; Loop round make code
             DoLine  64,32,%32                     ; Loop round make code
             DoLine  64,33,%33                     ; Loop round make code
             DoLine  64,34,%34                     ; Loop round make code
             DoLine  64,35,%35                     ; Loop round make code
             DoLine  64,36,%36                     ; Loop round make code
             DoLine  64,37,%37                     ; Loop round make code
             DoLine  64,38,%38                     ; Loop round make code
             DoLine  64,39,%39                     ; Loop round make code
             DoLine  64,40,%40                     ; Loop round make code

             DoLine  64,41,%41                     ; Loop round make code
             DoLine  64,42,%42                     ; Loop round make code
             DoLine  64,43,%43                     ; Loop round make code
             DoLine  64,44,%44                     ; Loop round make code
             DoLine  64,45,%45                     ; Loop round make code
             DoLine  64,46,%46                     ; Loop round make code
             DoLine  64,47,%47                     ; Loop round make code
             DoLine  64,48,%48                     ; Loop round make code
             DoLine  64,49,%49                     ; Loop round make code
             DoLine  64,50,%50                     ; Loop round make code

             DoLine  64,51,%51                     ; Loop round make code
             DoLine  64,52,%52                     ; Loop round make code
             DoLine  64,53,%53                     ; Loop round make code
             DoLine  64,54,%54                     ; Loop round make code
             DoLine  64,55,%55                     ; Loop round make code
             DoLine  64,56,%56                     ; Loop round make code
             DoLine  64,57,%57                     ; Loop round make code
             DoLine  64,58,%58                     ; Loop round make code
             DoLine  64,59,%59                     ; Loop round make code
             DoLine  64,60,%60                     ; Loop round make code

             DoLine  64,61,%61                     ; Loop round make code
             DoLine  64,62,%62                     ; Loop round make code
             DoLine  64,63,%63                     ; Loop round make code
             DoLine  64,64,%64                     ; Loop round make code
         endm

;******************************************************************************
;
; Actual code bits, lines then tables
;
;******************************************************************************
ScaleLines proc
           public   ScaleLines

           DoSprite 64

ScaleLines Endp

ScaleLineTable proc
           public  ScaleLineTable
           dd      TmpX_1
           dd      TmpX_2
           dd      TmpX_3
           dd      TmpX_4
           dd      TmpX_5
           dd      TmpX_6
           dd      TmpX_7
           dd      TmpX_8
           dd      TmpX_9
           dd      TmpX_10

           dd      TmpX_11
           dd      TmpX_12
           dd      TmpX_13
           dd      TmpX_14
           dd      TmpX_15
           dd      TmpX_16
           dd      TmpX_17
           dd      TmpX_18
           dd      TmpX_19
           dd      TmpX_20

           dd      TmpX_21
           dd      TmpX_22
           dd      TmpX_23
           dd      TmpX_24
           dd      TmpX_25
           dd      TmpX_26
           dd      TmpX_27
           dd      TmpX_28
           dd      TmpX_29
           dd      TmpX_30

           dd      TmpX_31
           dd      TmpX_32
           dd      TmpX_33
           dd      TmpX_34
           dd      TmpX_35
           dd      TmpX_36
           dd      TmpX_37
           dd      TmpX_38
           dd      TmpX_39
           dd      TmpX_40

           dd      TmpX_41
           dd      TmpX_42
           dd      TmpX_43
           dd      TmpX_44
           dd      TmpX_45
           dd      TmpX_46
           dd      TmpX_47
           dd      TmpX_48
           dd      TmpX_49
           dd      TmpX_50

           dd      TmpX_51
           dd      TmpX_52
           dd      TmpX_53
           dd      TmpX_54
           dd      TmpX_55
           dd      TmpX_56
           dd      TmpX_57
           dd      TmpX_58
           dd      TmpX_59
           dd      TmpX_60

           dd      TmpX_61
           dd      TmpX_62
           dd      TmpX_63
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64

           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
           dd      TmpX_64
ScaleLineTable endp


;******************************************************************************
;
;    Draw a scaled sprite. if over 64 pixels wide - ignore.
;
;         Tx1,Ty1    : word;
;         TDy        : word;
;         TDx        : Dword;
;         Tx2        : Dword;
;         TScaleX    : Dword;
;         TShape     : Dword;
;
;     xx:=(x1*$10000)+$8000;                 { get X start cord }
;     yy:=(y1*$10000)+$8000;                 { get Y start cord }
;     y:=$8000;                                 { texture Y half way through pixel }
;     repeat
;           xx2:=xx;
;           x:=0;
;           index:=(xx shr 16)+((yy shr 16)*320);
;           tindex:=(y shr 10) and $ffffffc0;      { (y shr 16)*64 }
;           repeat
;                 Screen^[index]:=  shape^[(x shr 16)+tindex];
;
;                 inc (x,tScaleX);            { do scale on X        }
;                 inc (index);                { next pixel on screen }
;           until (x>$400000);
;           inc (y,scy);
;           inc (yy,aa);
;           inc (xx,dx1);
;           t2:=t2+scaleX;
;           tScaleX:=$400000 div ((t2-xx+$10000) shr 16);
;     until (y>$400000);*)
;
;******************************************************************************
DrawaScaledBlock  proc far
                  public DrawScaledBlock

ty           dd    0
_Dx          dd    0
_Dy          dd    0
_tScy        dd    0
_ScaleX      dd    0
_x2          dd    0
_tt          dd    0

DrawScaledBlock:
          SSTack
 		push	di
          push	es
          push	ds


          mov  eax,TscaleX    ; Copy Paramaters over
          mov  _ScaleX,eax
          mov  eax,Tscy       ; Copy Paramaters over
          mov  _tScy,eax
          mov  eax,Tdx        ; Copy Paramaters over
          mov  _Dx,eax
          mov  eax,Tdy
          mov  _Dy,eax
          mov  eax,Tx2
          mov  _x2,eax

          mov  cx,Tx1         ; scale x cord up!
          shl  ecx,16
          mov  ax,Ty1         ; scale Y cord up!
          shl  eax,16
          mov  edx,08000h

          les  di,Plane1
		lds	si,TShape		 ; get graphic address

@SLoop:
          push si
          push di

          mov  ebx,eax         ; work out NEW X,Y pos on screen.
          shr  ebx,16
          add  bx,bx
          add  di,word ptr _Table[bx]    ;[ebx*2] is better
          shld ebx,ecx,16      ; Get X cord and add on.
          add  di,bx

          cmp  eax,200*010000h
          jae  @SkipX

          mov  ebx,edx          ; work out new start in texture
          shr  ebx,10           ; (new start LINE)
          and  bx,0ffc0h
          add  si,bx


          mov  ebx,_x2         ; Work out address for line printing Jump table
          sub  ebx,ecx         ; Get WIDTH to print!
          shr  ebx,14          ; shr 16, *4
          and  bx,65535-3
          add  bx,offset ScaleLineTable
          call cs:[bx]

@SkipX:
          mov  ebx,_ScaleX    ; Line Draw on X (right side)
          add  _X2,ebx
          add  eax,_Dy
          add  ecx,_Dx        ; Line draw on X,Y (left side)
          add  edx,_tScy       ; Scale Texture on Y axis

          pop  di
          pop  si
          cmp  edx,0400000h
          jle  @SLoop


@TExit:	pop	ds
          pop	es
          pop	di

          RSTACK
          ret

DrawaScaledBlock   endp

;******************************************************************************
;
;    Draw a scaled sprite. if over 64 pixels wide - ignore.
;    as above, but clipped on X.
;
;******************************************************************************
DrawaScaledBlockC  proc far
                  public   DSBClipped

          EVENDATA
cnt       =    0
SkipTable:
          rept      63
          dw  cnt
cnt       = cnt+9
          endm
          rept 200
          dw   64*9
          endm
_Xclip    dw   0
_Xsize    dw   0

DSBClipped:
          SSTack
 		push	di
          push	es
          push	ds


          mov  eax,TscaleX    ; Copy Paramaters over
          mov  _ScaleX,eax
          mov  eax,Tscy       ; Copy Paramaters over
          mov  _tScy,eax
          mov  eax,Tdx        ; Copy Paramaters over
          mov  _Dx,eax
          mov  eax,Tdy
          mov  _Dy,eax
          mov  eax,Tx2
          mov  _x2,eax

          mov  cx,Tx1         ; scale x cord up!
          shl  ecx,16
          mov  ax,Ty1         ; scale Y cord up!
          shl  eax,16
          mov  edx,08000h

          les  di,Plane1
		lds	si,TShape		 ; get graphic address

@SLoop2:
          push si
          push di

          mov  ebx,eax         ; work out NEW X,Y pos on screen.
          shr  ebx,16
          add  bx,bx
          add  di,word ptr _Table[bx]    ;[ebx*2] is better
          shld ebx,ecx,16      ; Get X cord and add on.
          add  di,bx

          cmp  eax,200*010000h
          jae  @SkipX2

          mov  ebx,edx          ; work out new start in texture
          shr  ebx,10           ; (new start LINE)
          and  bx,0ffc0h
          add  si,bx


          mov  _Xclip,0
          mov  _Xsize,0
          mov  ebx,ecx         ; Work out address for line printing Jump table
          cmp  ebx,0
          jge  @ok
          shr  ebx,16
          neg  bx
          mov  _Xsize,bx
          add  bx,bx           ; Get CLIP size
          mov  bx,word ptr SkipTable[bx]
          mov  _Xclip,bx

@ok:      mov  ebx,_x2
          sub  ebx,ecx         ; Get WIDTH to print!
          shr  ebx,16          ; shr 16, *4
          cmp  bx,_Xsize
          jl   @SkipX2

          add  bx,bx
          add  bx,bx
          add  bx,offset ScaleLineTable
          mov  bx,cs:[bx]
          add  bx,_Xclip
          call bx

@SkipX2:
          mov  ebx,_ScaleX    ; Line Draw on X (right side)
          add  _X2,ebx
          add  eax,_Dy
          add  ecx,_Dx        ; Line draw on X,Y (left side)
          add  edx,_tScy       ; Scale Texture on Y axis

          pop  di
          pop  si
          cmp  edx,0400000h
          jle  @SLoop2


@TExit2:	pop	ds
          pop	es
          pop	di

          RSTACK
          ret

DrawaScaledBlockC   endp
